//
//  GameView.h
//  Snakes
//
//  Created by Vince Tagle on 12/17/04.
//  Copyright 2004 __MyCompanyName__. All rights reserved.
//

#import <Cocoa/Cocoa.h>


/*
	Since the Cocoa constants for arrow keys are left shifted by 16, 
	they can't fit in the bool array. So they're being defined at the end
	going inwards.
*/
enum GameViewKeys 
{
	gvArrowKeyUp = 255,
	gvArrowKeyDown = 254,
	gvArrowKeyLeft = 253,
	gvArrowKeyRight = 252
};

@interface GameView : NSView 
{
	// fields for keyboard handling
	// 
	BOOL	keys[256];
	int		key_pressed_for_keycode[256];
	BOOL	opt, ctrl, command, shift;
}

/*!	\brief	Returns whether or not the current game is over. 
*/
- (BOOL)gameOver;  

/*!	\brief	Returns the width of the game grid. 
*/
- (UInt32)gridWidth; 

/*!	\brief	Returns the height of the game grid. 
*/
- (UInt32)gridHeight; 

- (BOOL)isDown: (int)key;
- (BOOL)isOptDown;
- (BOOL)isCtrlDown;
- (BOOL)isCommandDown;
- (BOOL)isShiftDown;
- (int)numKeys;

@end
